#!/usr/bin/php
<?php
set_include_path(get_include_path() . PATH_SEPARATOR . "/usr/local/mgr5/include/php");
define('__MODULE__', "pmenot");
require_once 'billmgr_util.php';

echo "Content-Type: text/html; charset=utf-8\n\n";

//Debug('enotresult.php was called');

if (!function_exists('hash_equals')) {
	function hash_equals($str1, $str2) {
		if (strlen($str1) != strlen($str2)) return false;
		$res = $str1 ^ $str2;
		$ret = 0;
		for ($i = strlen($res) - 1; $i >= 0; $i--) {
			$ret |= ord($res[$i]);
		}
		return !$ret;
	}
}

if ($_SERVER['REQUEST_METHOD'] !== 'POST') {
	Error('callback # enot: Invalid method.');
	exit;
}

$signature_header = $_SERVER['HTTP_X_API_SHA256_SIGNATURE'] ?? '';
	
if(empty($signature_header)) {
	Error('callback # enot: Empty signature.');
	exit;
}

$params = CgiInput(true);

if (empty($params)) {
	Error("callback # enot: Empty params.");
	exit;
} 

$order_id = $params["order_id"] ?? null;

if (!$order_id) {
	Error('callback # enot: order_id not set');
	exit;
}

$order_arr = explode('_', $order_id);
$elid = (int)$order_arr[1] ?? null;

if (!$elid) {
	Error('callback # enot: incorrect order_id');
	exit;
}

$info = LocalQuery("payment.info", array("elid" => $elid));

if (!$info->payment->id) { //заказ не существует в BM
	Error("Order $elid not found in BM!");
	exit;
}

$status = $params['status'] ?? 'unknown';

if ($status != 'success') {
    Error("callback # enot: Unsuccessful order status for order $elid - $status");
    exit;
}

$sum = $info->payment[0]->paymethodamount;
$cur_currency = (string)$info->payment[0]->currency[1]->iso;

$paymethod_params = (array) $info->payment->paymethod[1];

$merchant_id = $paymethod_params["merchant_id"];
$secret_word2 = $paymethod_params["secret_word2"];
	
$sign = $params;
ksort($sign);
$sign = json_encode($sign);
$calculated_signature = hash_hmac('sha256', $sign, $secret_word2);
	
if (!hash_equals($signature_header, $calculated_signature)) {
	Error('callback # enot: Invalid signature.');
	exit;
}

LocalQuery("payment.setpaid", array("elid" => $elid, 'externalid' => $params['invoice_id'], 'info' => print_r($params, true)));
Debug("payment.setpaid OK {$order_id}");


?>